// The header file defining the node in sparse matrix.
// It could be any type.

#ifndef __NODE_H__
#define __NODE_H__

#include <iostream.h>
//#include "row.h"

using namespace std;

typedef int T;

// class row;

class spMat;

template <class T>
class spNode {
	int colNum, rowNum;
	//int *val;     // a pointer back to original object
    T *val;     // a pointer back to original object

	static	spMat *array; 
	//row< node < T > > *array; 

public:
    // Constructors and destructor
	//node ( const node<T>* n )

	// node ( row* rowPtr, const int rownumber, const int colnumber, const T nvalue )
	node ( const int rownumber, const int colnumber, const T nvalue )
	{
		this->rowNum = rownumber;
		this->colNum = colnumber;
		*this->val = nvalue;
	}

	// promotion constructor - used when saving a pointer to object
	// This is from the code of Dr. Fawcett's sample
	// node( const T *tptr ) { val = tptr; }
	node( const T *tptr ) { *val = *tptr; }

    node () { array = 0; rowNum = 0; colNum = 0; *val = (T) 0; }

	~node() { }

	// assignment - used when writing a T to a proxy
	// This is from the code of Dr. Fawcett's sample
	void operator=(const T &t) 
	{
		if( t != 0 ) {
			*this->val = t;
		} else {
			array->remove(this);
			delete this;
		}
	}

	// == operator overload
	/* bool operator ==( node& n ) { return ( *val == (n.value() ) ) ; }
	bool operator !=( node& n ) { return ( *val != (n.value() ) ) ; }
	bool operator >( node& n ) { return ( *val > (n.value() ) ) ; } */

	// cast operator - used when reading a T from a proxy
	// This is from the code of Dr. Fawcett's sample
	operator const T() { return *( this->val ); }

	// get column number
	const int colNumber() { return this->colNum; }
	const int value() { return *val; }

};
#endif